<?php
/*
 * Class Name : GFHANNANSMS_Pro_{strtoupper( php file name) }	
 */
class GFHANNANSMS_Pro_ASANAK {

	/*
	* Gateway title	
	*/
	public static function name($gateways) {
	
		$name = __('آسانک', 'GF_SMS' );
		
		$gateway = array( strtolower( str_replace( 'GFHANNANSMS_Pro_', '', get_called_class())) => $name );
		return array_unique( array_merge( $gateways , $gateway ) );
	}
	
	
	/*
	* Gateway parameters
	*/
	public static function options(){
		return array(
			'username'  => __('نام کاربری','GF_SMS'),
			'password'  => __('پسورد','GF_SMS'),
		);
	}

	/*
	* Gateway credit
	*/
	public static function credit(){
		return true;
	}
	

	/*
	* Gateway action
	*/	
	public static function process( $options, $action, $from, $to, $messages ){
	
		if ( $action == 'credit' && !self::credit() ) {
			return false;
		}
				
		$username = $options['username'];
		$password = $options['password'];
		
		ini_set("soap.wsdl_cache_enabled", "0");
		
		$to = explode(',', $to);
		$i = sizeOf($to);
		while($i--){
			$uNumber = Trim($to[$i]);
			$ret = &$uNumber;
			if (substr($uNumber,0, 5) == '%2B98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 5) == '%2b98'){ 
				$ret = substr($uNumber, 5);
			}
			if (substr($uNumber,0, 4) == '0098'){ 
				$ret = substr($uNumber, 4);
			}
			if (substr($uNumber,0, 3) == '098')	{ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 3) == '+98'){ 
				$ret = substr($uNumber, 3);
			}
			if (substr($uNumber,0, 2) == '98'){ 
				$ret = substr($uNumber, 2);
			}
			$to[$i] =  '0' . ltrim($ret, '+');
		}
			
	$from1=$from;
	if ($action == "send") {
		try {
			$parameters['to'] = $to;
	
			if (count($parameters['to']) > 1) {
				$dest = implode(',', $parameters['to']);
			} else {
				$dest = $parameters['to'][0];
			}
	
			$url = "https://panel.asanak.com/webservice/v2rest/sendsms";
	
			$body = array(
				'username'    => $username,
				'password'    => $password,
				'source'      => $from1,
				'destination' => $dest,
				'message'     => trim($messages),
			);
	
			$args = array(
				'method'    => 'POST',
				'body'      => $body, // ارسال به‌صورت فرم‌دیتا
				'headers'   => array(
					'Content-Type' => 'application/x-www-form-urlencoded'
				),
			);
	
			$sendResult = wp_remote_request($url, $args);
	
			if (is_wp_error($sendResult)) {
				return __('خطا در ارتباط با سرور.', 'GF_SMS');
			}
	
			$response_code = wp_remote_retrieve_response_code($sendResult);
			$body = wp_remote_retrieve_body($sendResult);
			$response_data = json_decode($body, true);
	
			if ($response_code == 403) {
				return __(': محدودیت IP .', 'GF_SMS');
			}
	
			if (!empty($response_data['meta']['status']) && !empty($response_data['meta']['message'])) {
				$status = (int) $response_data['meta']['status'];
				$message = $response_data['meta']['message'];
	
				if ($status == 200) {
					return 'OK';
				} else {
					return __('خطا: ', 'GF_SMS') . $message;
				}
			} else {
				return __('خطای ناشناخته. لطفاً دوباره امتحان کنید.', 'GF_SMS');
			}
		} catch (Exception $ex) {
			return __('خطای سرور: ', 'GF_SMS') . $ex->getMessage();
		}
	}
	
	
	
	
	

	if ($action == "credit") {
		$url = "https://panel.asanak.com/webservice/v2rest/getcredit";
	
		$body = array(
			'username' => $username,
			'password' => $password
		);
	
		$args = array(
			'method'    => 'POST',
			'body'      => $body, // ارسال اطلاعات به‌صورت فرم‌دیتا
			'headers'   => array(
				'Content-Type' => 'application/x-www-form-urlencoded'
			),
		);
	
		$res = wp_remote_request($url, $args);
	
		if (is_wp_error($res)) {
			return __('خطا در دریافت اطلاعات.', 'GF_SMS');
		}
	
		$response_body = json_decode(wp_remote_retrieve_body($res), true);
	
		if (json_last_error() === JSON_ERROR_NONE && isset($response_body['data']['credit'])) {
			return (int) $response_body['data']['credit'] . __(' پیامک', 'GF_SMS');
		} else {
			return __('نام کاربری یا کلمه عبور اشتباه است.', 'GF_SMS');
		}
	}
	
		
		// if ($action == "send"){

		// 	if( $send == 11 ){
		// 		return __('پیامک ارسال نشده است .', 'GF_SMS' );
		// 	}
		// 	else if ( $send == 1){
		// 		return 'OK';
		// 	}
		// 	else {
		// 		return __('خطای ناشناخته .', 'GF_SMS' );
		// 	}
		// }
		
		// if ($action == "credit") {
		// 	if ( $credit == 0 ) {
		// 		return __('نام کاربری یا کلمه عبور اشتباه است .', 'GF_SMS' );
		// 	}
		// 	return ( (int) $credit ) . __(' پیامک', 'GF_SMS' );
		// }

		
		if ($action == "range"){
			$min = 100;
			$max = 200;
			return array("min" => $min, "max" => $max);
		}

	}
}